/**
 * 
 */
package cm;

/**
 * 
 *Cette classe dfinit l'objet <code> Vehicule </code>. Un objet Vehicule est dfini par son nom, sa couleur, son nombre de roues...On peut le faire dmarrer, l'arrter, le faire acclrer, comparer la vitesse de deux Vehicule...
 *
 *<br/>
 *Exemple : <br/>
 *
 *Vehicule monVelo; // declaration <br/>
 *monVelo = new Vehicule("Velo","bleu",2,50.0); // cration <br/>
 *monVelo.getEstDemarre(); // appel d'une mthode <br/>
 *... <br/>
 *System.out.println(monVelo); // affichage de l'objet <br/>
 *@author jean-franois Remm
 */
public class Vehicule {
	private String nom;
	private String couleur;
	private int nbRoues;
	private double vitesse;
	private double vitesseMax;
	private boolean estDemarre;
	
	/**
	 * Cr un nouveau Vehicule initialis aux paramtres donns <br/>
	 * @param nomVehicule
	 * @param couleurInitiale
	 * @param nombreRoues
	 * @param vitesseMaximum
	 * 
	 */
	public Vehicule(String nomVehicule, String couleurInitiale, int nombreRoues, double vitesseMaximum)
	{
		this.nom = nomVehicule;
		this.couleur = couleurInitiale;
		this.nbRoues  = nombreRoues;
		this.vitesse = 0.0;
		this.vitesseMax = vitesseMaximum;
		this.estDemarre = false;
	}
	
	
	/**
	 * Acclre le Vehicule de accelereration si celui-ci est en marche, sans dpasser la vitesse maximum
	 * @param accelereration
	 */
	public void accelerer(double accelereration)
	{
		this.vitesse = this.vitesse + accelereration;
		if (this.vitesse > this.vitesseMax)
			this.vitesse = this.vitesseMax;
	}
	
	/**
	 * Arrte le vhicule
	 */
	public void arreter()
	{
		this.estDemarre = false;
		this.vitesse = 0.0;
	}
	
	/**
	 * Ralentit le Vehicule de decelereration si celui-ci est en marche.
	 * @param decelereration
	 */
	public void decelerer(double decelereration)
	{
		if (this.estDemarre)
		{
			this.vitesse = this.vitesse - decelereration;
			if (this.vitesse < 0)
				this.vitesse = 0;
		}
	}
	
	/**
	 * Dmarre le Vehicule
	 */
	public void demarrer()
	{
		this.estDemarre = true;
	}
	
	/**
	 * renvoie true si le Vehicule est en marche, false dans le cas contraire.
	 * @return true si le vehicule est en marche
	 */
	public boolean getEstDemarre()
	{
		return this.estDemarre;
	}
	
	/**
	 * Donne la vitesse du Vhicule
	 * @return la vitesse du vehicule
	 */
	public double getVitesse()
	{
		return this.vitesse;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 * renvoie une chane de caractres qui dcrit le Vehicule courant (utilis de manire implicite lorque l'on fait System.out.println(unVehicule))
	 */
	public  String toString()
	{
		String s = "nom : "+this.nom + "\n"+
		"couleur : "+this.couleur+"\n"+
		"Nombre de roues : "+this.nbRoues+"\n"+
		"Vitesse : "+this.getVitesse() +"\n"+
		"Vitesse Maximale : "+this.vitesseMax +"\n"+
		"Demarre : "+this.estDemarre;
		return s;
	}
	
	/**
	 * Compare la vitesse du vhicule sur lequel j'applique la mthode avec la vitesse du vhicule autre donn en paramtre.
	 * @param autre un autre vehicule
	 * @return true si le vehicule est le plus rapide
	 */
	public boolean vaPlusVite(Vehicule autre)
	{
		return this.vitesse > autre.getVitesse();
	}
}
