package tp.mesClasses;

/**
 * La classe Notes reprsente la note de l'ue1 et la note de l'ue2
 * @author jub
 *
 */
public class Notes {
	/**
	 * La note de l'ue1;
	 */
	private double ue1;
	/**
	 * La note de l'ue2
	 */
	private double ue2;
	
	/**
	 * Construit des notes avec 0 pour l'ue1 et 0 pour l'ue2
	 */
	public Notes() {
		this(0,0);
	}
	
	/**
	 * Construit des notes avec des valeures choisies
	 * @param ue1 la note de l'ue1
	 * @param ue2 la note de l'ue2
	 */
	public Notes(double ue1, double ue2) {
		this.ue1 = ue1;
		this.ue2 = ue2;
	}
	
	/**
	 * Constuit des notes par recopie
	 * @param notes les notes  recopier
	 */
	public Notes(Notes notes)
	{
		this(notes.ue1, notes.ue2);
	}

	/**
	 * Permet de savoir si deux jeux de notes sont gaux
	 * @param autres les notes  comparer
	 * @return true si les notes sont gales ue par ue et false sinon
	 */
	public boolean estEgal(Notes autres)
	{
		return this.ue1 == autres.ue1 && this.ue2==autres.ue2;
	}

	/**
	 * Calcul la moyenne entre les deux ue
	 * @return la moyenne des ue
	 */
	public double getMoyenne()
	{
		return (this.ue1 + this.ue2)/2;
	}

	/**
	 * Permet de connatre la note de l'ue1
	 * @return la note de l'ue1
	 */
	public double getUe1() {
		return ue1;
	}

	/**
	 * Permet de connatre la note de l'ue2
	 * @return la note de l'ue2
	 */
	public double getUe2() {
		return ue2;
	}
	
	/**
	 * Permet de savoir si un semestre est valid (ue1>=8 et ue2>=8 et moyenne>=10)
	 * @return true si le semestre est valid et false sinon.
	 */
	public boolean semestreOk()
	{
		return ue1 >=8 && ue2 >=8 && this.getMoyenne()>=10;
	}
	/**
	 * Permet de modifier la note de l'ue1
	 * @param ue1 la nouvelle note
	 */
	public void setUe1(double ue1) {
		this.ue1 = ue1;
	}

	
	/**
	 * Permet de modifier la note de l'ue2
	 * @param ue2 la nouvelle note
	 */
	public void setUe2(double ue2) {
		this.ue2 = ue2;
	}
	
	@Override
	public String toString() {
		return "Notes [ue1=" + ue1 + ", ue2=" + ue2 + "]";
	}
	
	
}
