package tp.mesClasses;

import java.util.Date;
/**
 * Cette classe dfinit l'objet <code>Personne</code>.  . On mmorise
 * trois informations, le nom de la personne, le prnom de la personne
 * et la date de naissance de la personne. On peut comparer l'age de
 * personnes.
 *
 * @version 22 fevrier 2011 
 * @author Remm Jean-Francois 
 */
public class Personne {

	/**
	 * Le nom de la  <code>Personne</code>
	 */
	private String nom;

	/**
	 * Le prnom de la  <code>Personne</code>
	 */
	private String prenom;

	/**
	 * La date de naissance de la  <code>Personne</code>
	 */
	private Date naiss;

	/** Cr une nouvelle <code>Personne</code> initialise aux
	 * paramtres donns. Le nom est automatiquement converti en
	 * majuscules. Le prnom est automatiquement converti en
	 * minuscules. La date de naissance de la <code>Personne</code>
	 * est la <code>Date</code> du jour.
	 *
	 * @param nom le nom de la <code>Personne</code>
	 * @param prenom le prnom du <code>Personne</code> */
	public Personne(String nom, String prenom)
	{
		this(nom, prenom, new Date());
	}


	/** Cr une nouvelle <code>Personne</code> initialise aux
	 * paramtres donns. Le nom est automatiquement converti en
	 * majuscules. Le prnom est automatiquement converti en
	 * minuscules. Un alias peut-tre utilis pour les dates.
	 *
	 * @param nomIni le nom de la <code>Personne</code>
	 * @param prenomIni le prnom du <code>Personne</code>
	 * @param naissIni la date de naissance de la <code>Personne</code> */
	public Personne(String nomIni, String prenomIni, Date naissIni)
	{
		this.nom = nomIni.toUpperCase();
		this.prenom = prenomIni.toLowerCase();
		this.naiss = naissIni;
	}

	

	/** 
	 * Donne la date de naissance de la <code>Personne</code>
	 */ 
	public Date getNaissance()
	{
		return(this.naiss);
	}

	/** 
	 * Donne le nom de la <code>Personne</code>
	 */ 
	public String getNom()
	{
		return(this.nom);
	}

	/** 
	 * Donne le prnom de la <code>Personne</code>
	 */ 
	public String getPrenom()
	{
		return(this.prenom);
	}


	/** 
	 * Compare l'ge de la <code>Personne</code> sur laquelle
	 * j'applique la mthode avec l'ge de la <code>Personne</code>
	 * <code>autre</code> donn en paramtre. Renvoie
	 * <code>false</code> si <code>autre</code> est la plus vieille,
	 * <code>true</code> dans le cas contrainre.
	 *
	 * @param autre l'autre <code>Personne</code>
	 * */
	public boolean plusAgee(Personne autre)
	{
		return(this.naiss.before(autre.naiss));
	}

	/** 
	 * Change le nom de la <code>Personne</code> (en cas de mariage
	 * par exemple).
	 *
	 * @param newNom le nouveau nom de la <code>Personne</code>
	 *
	 */
	public void setNom(String newNom)
	{
		this.nom = newNom;
	}

	/** renvoie une chane de caractres qui dcrit la
	 * <code>Personne</code> courant (utilis de manire implicite lorque
	 * l'on fait <code>System.out.println(unePersonne)</code>) 
	 */


	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		StringBuffer temp;
		temp = new StringBuffer();
		temp.append(nom);
		temp.append(" ");
		temp.append(prenom);
		temp.append(" n le ");
		temp.append(naiss);
		return(new String(temp));
	}


	
}


