package tp.mesClasses;

import java.util.Date;
/**
 * Cette classe dfinit l'objet <code>Personne</code>.  . On mmorise
 * trois informations, le nom de la personne, le prnom de la personne
 * et la date de naissance de la personne. On peut comparer l'age de
 * personnes.
 *
 * @version 27 fevrier 2010 
 * @author Remm Jean-Francois 
 */
public class PersonnePlus implements Comparable<PersonnePlus>
{

	/**
	 * Le nom de la  <code>Personne</code>
	 */
	private String nom;

	/**
	 * Le prnom de la  <code>Personne</code>
	 */
	private String prenom;

	/**
	 * La date de naissance de la  <code>Personne</code>
	 */
	private Date naiss;

	/** Cr une nouvelle <code>Personne</code> initialise aux
	 * paramtres donns. Le nom est automatiquement converti en
	 * majuscules. Le prnom est automatiquement converti en
	 * minuscules. La date de naissance de la <code>Personne</code>
	 * est la <code>Date</code> du jour.
	 *
	 * @param nom le nom de la <code>Personne</code>
	 * @param prenom le prnom du <code>Personne</code> */
	public PersonnePlus(String nom, String prenom)
	{
		this(nom, prenom, new Date());
	}


	/** Cr une nouvelle <code>Personne</code> initialise aux
	 * paramtres donns. Le nom est automatiquement converti en
	 * majuscules. Le prnom est automatiquement converti en
	 * minuscules.
	 *
	 * @param nomIni le nom de la <code>Personne</code>
	 * @param prenomIni le prnom du <code>Personne</code>
	 * @param naissIni la date de naissance de la <code>Personne</code> */
	public PersonnePlus(String nomIni, String prenomIni, Date naissIni)
	{
		this.nom = nomIni.toUpperCase();
		this.prenom = prenomIni.toLowerCase();
		this.naiss = naissIni;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (! (obj instanceof PersonnePlus))
			return false;
		PersonnePlus personne = (PersonnePlus) obj;
		return this.naiss.equals(personne.naiss) &&
		this.nom.equals(personne.nom) &&
		this.prenom.equals(personne.prenom);
	}


	/** 
	 * Donne la date de naissance de la <code>Personne</code>
	 */ 
	public Date getNaissance()
	{
		return(this.naiss);
	}

	/** 
	 * Donne le nom de la <code>Personne</code>
	 */ 
	public String getNom()
	{
		return(this.nom);
	}

	/** 
	 * Donne le prnom de la <code>Personne</code>
	 */ 
	public String getPrenom()
	{
		return(this.prenom);
	}


	/** 
	 * Compare l'ge de la <code>Personne</code> sur laquelle
	 * j'applique la mthode avec l'ge de la <code>Personne</code>
	 * <code>autre</code> donn en paramtre. Renvoie
	 * <code>false</code> si <code>autre</code> est la plus vieille,
	 * <code>true</code> dans le cas contrainre.
	 *
	 * @param autre l'autre <code>Personne</code>
	 * */
	public boolean plusAgee(PersonnePlus autre)
	{
		return(this.naiss.before(autre.naiss));
	}

	/** 
	 * Change le nom de la <code>Personne</code> (en cas de mariage
	 * par exemple).
	 *
	 * @param newNom le nouveau nom de la <code>Personne</code>
	 *
	 */
	public void setNom(String newNom)
	{
		this.nom = newNom;
	}

	/** renvoie une chane de caractres qui dcrit la
	 * <code>Personne</code> courant (utilis de manire implicite lorque
	 * l'on fait <code>System.out.println(unePersonne)</code>) 
	 */


	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		StringBuffer temp;
		temp = new StringBuffer();
		temp.append(nom);
		temp.append(" ");
		temp.append(prenom);
		temp.append(" n le ");
		temp.append(naiss);
		return(new String(temp));
	}


	@Override
	public int compareTo(PersonnePlus o) {
		int nomOk, prenomOk, naissOk;
		nomOk = this.nom.compareTo(o.nom);
		prenomOk = this.prenom.compareTo(o.prenom);
		naissOk = this.naiss.compareTo(o.naiss);
		if (nomOk == 0)
			if (prenomOk == 0)
				return naissOk; 
			else
				return prenomOk;
		else
			return nomOk;

	}
}


