package tp.mesClasses;

/**
 * La classe Point dfinie des points caractriss par une abscisse x et une ordonne
 * @author jub
 *
 */
public class Point {
	/**
	 * un point est caractris par son abscisse x et son ordonne y
	 */
	private int x, y;


	/**
	 * Construit un Point en coordonnes (0,0)
	 */
	public Point() {
		//this(0,0);
		this.x = 0;
		this.y = 0;
	}
	
	/**
	 * Construit un Point de coodonnes (x,y) choisies 
	 * @param x l'abscisse choisie
	 * @param y l'ordonne choisie
	 */
	public Point(int x, int y) {

		this.x = x;
		this.y = y;
	}
	
	/**
	 * Construit un point qui est la copie d'un autre
	 * @param p l'autre Point
	 */
	public Point(Point p) {
		//this(p.x,p.y);
		this.x = p.x;
		this.y = p.y;
	}
	/**
	 * Deplace le point aux nouvelles coordonnes
	 * @param x la nouvelle abscisse 
	 * @param y la nouvelle ordonne
	 */
	public void deplacer(int x, int y)
	{
		this.x = x;
		this.y = y;
	}
	/**
	 * Permet la compraison entre le point courant et un autre point
	 * @param p l'autre point
	 * @return true si les abscisses et les ordonnes sont gales et false sinon.
	 */
	public boolean estEgal(Point p)
	{
		return (this.x == p.x && this.y == p.y);
	}
	/**
	 * Renvoie l'abscisse
	 * @return l'abscisse
	 */
	public int getX() {
		return this.x;
	}
	/**
	 * Renvoie l'ordonne
	 * @return l'ordonne
	 */
	public int getY() {
		return this.y;
	}

	/**
	 * Permet de modifier l'abscisse 
	 * @param x la nouvelle abscisse
	 */
	public void setX(int x) {
		this.x = x;
	}

	/**
	 * Permet de modifier 
	 * @param y
	 */
	public void setY(int y) {
		this.y = y;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "Point [x=" + this.x + ", y=" + this.y + "]";
	}
	
	/**
	 * Translate le point de dx en abscisse et dy en ordonne
	 * @param dx la translation en abscisse
	 * @param dy la translation en ordonne
	 */
	public void translater(int dx, int dy)
	{
		//this.x +=dx;
		//this.y +=dy;
		this.x = this.x + dx;
		this.y = this.y + dy;
	}
	
}
