package tp.mesClasses;

import java.util.Arrays;

/**
 * Cette classe dcrit une promotion d'tudiants
 * @author jub
 *
 */
public class Promotion {
	/**
	 * La promotion est un tableau d'tudiants
	 */
	Etudiant[] promotion;

	/**
	 * Permet de construire une promotion sans tudiants
	 */
	public Promotion(){
		this.promotion=null; //ou pour viter les tests sur les nulls this.promotion = new Etudiant[0];
	}

	/**
	 * Permet de construire une promotion  partir d'un tableau d'tudiants
	 * @param promotion
	 */
	public Promotion(Etudiant[] promotion) {
		this.promotion = promotion;
	}

	/**
	 * Permet d'ajouter un tudiant  la promotion
	 * @param e l'tudiant  ajouter
	 */
	public void ajoutEtudiant(Etudiant e){
		if (this.promotion != null){
			Etudiant[] nouvellePromotion;
			nouvellePromotion = new Etudiant[this.promotion.length+1];
			for(int i=0; i < this.promotion.length; i++)
			{
				nouvellePromotion[i]= this.promotion[i];
			}
			nouvellePromotion[this.promotion.length]=e;
			this.promotion = nouvellePromotion;
		}
		else
		{
			this.promotion=new Etudiant[1];
			this.promotion[0]=e;
		}
	}

	/**
	 * Permet de connatre l'effectif de la promotion
	 * @return l'effectif
	 */
	public int effectif(){
		int res =0;
		if (this.promotion != null)
			res= this.promotion.length;
		return res;
	}


	/**
	 * Permet de connatre souis forme de tableau les tudiants qui ont le semestre
	 * @return le tableau des tudiants admis.
	 */
	public Etudiant[] etudiantAdmis()
	{
		Etudiant[] res = null;
		if (this.promotion != null){
			int cpt=0;
			for (int i=0; i < this.promotion.length; i++){
				if (this.promotion[i].semestreOk())
					cpt++;
			}
			res = new Etudiant[cpt];
			cpt=0;
			for (int i=0; i < this.promotion.length; i++){
				if (this.promotion[i].semestreOk())
				{
					res[cpt]=new Etudiant(this.promotion[i]);
					cpt++;
				}	
			}
		}
		return res;
	}

	/**
	 * Permet de connatre la moyenne de la promotion
	 * @return la moyenne de la promotion
	 */
	public double moyenne()
	{
		double res =0;
		if (this.promotion != null){
			int nb = this.promotion.length;
			for (int i=0; i < nb; i++){
				res = res + this.promotion[i].getMoyenne();
			}
			res = res /nb;
		}
		return res;
	}


	/**
	 * Permet de supprimer un ou plusieurs tudiants en connaissant un numro
	 * @param no le numro du ou des tudiants  supprimer
	 */
	public void suppressionEtudiantParNumero(int no){
		Etudiant[] nouvellePromotion;
		int cpt =0;
		for (int i=0; i < this.promotion.length; i++)
			if (this.promotion[i].getNumero() == no)
				cpt++;
		nouvellePromotion = new Etudiant[this.promotion.length-cpt];

		cpt =0;
		for (int i=0; i < this.promotion.length; i++)
			if (this.promotion[i].getNumero() != no)
			{
				nouvellePromotion[cpt]=this.promotion[i];
				cpt++;
			}
		this.promotion = nouvellePromotion;	
	}

	@Override
	public String toString() {
		return "Promotion [promotion=" + Arrays.toString(promotion) + "]";
	}



}
